%define version 0.8.3
%define rel 8
%define build_plf 0
%define release %mkrel %rel
%{?_with_plf: %{expand: %%global build_plf 1}}
%if %build_plf
%define distsuffix plf
%endif

%define req_mono_version 0.91
%define gtk_sharp_version 1.9.2

%define	gstname gstreamer
%define gstver 0.8.0
%define build_gst 1
%{?_with_gst: %{expand: %%global build_gst 1}}
%{?_without_gst: %{expand: %%global build_gst 0}}

%define monoprefix %_prefix/lib
Summary:	Music player for GNOME
Name:		muine
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		Sound
URL:		http://muine.gooeylinux.org/
Buildroot:	%{_tmppath}/%{name}-%{version}-buildroot
Source:		http://muine.gooeylinux.org/%{name}-%{version}.tar.bz2
Source1:	muine-0.8.3-dll.config.bz2
Patch: 		muine-0.8.3-plugindir.patch.bz2
Patch1:		muine-0.8.3-gtk-sharp-2.3.90.patch.bz2
BuildRequires:	gdbm-devel
BuildRequires:	gnome-vfs2-devel
BuildRequires:	gnome-sharp2 >= %gtk_sharp_version
BuildRequires:	glade-sharp2 >= %gtk_sharp_version
BuildRequires:	dbus-sharp
BuildRequires:	mono-tools
BuildRequires:	gtk+2-devel
BuildRequires:	libGConf2-devel
BuildRequires:	libid3tag-devel >= 0.15
BuildRequires:	libflac-devel
BuildRequires:	mono-devel >= %{req_mono_version}
BuildRequires:	oggvorbis-devel
BuildRequires:	ImageMagick
#gw broken intltool:
BuildRequires: perl-XML-Parser
%if %build_plf
BuildRequires: libfaad2-static-devel
%endif
Requires:	mono >= %{req_mono_version}
Requires: shared-mime-info >= 0.16
%if %build_gst
BuildRequires:	gstreamer-plugins-devel >= %gstver
Requires:	%gstname-GConf >= %gstver
Requires:	%gstname-vorbis >= %gstver
Requires:	%gstname-mad >= %gstver
Requires:	%gstname-flac >= %gstver
Requires:	%gstname-audio-effects >= %gstver
Requires:	%gstname-audiosink >= %gstver
%if %build_plf
Requires: %gstname-faad >= %gstver
%endif
%else
BuildRequires: libxine-devel
Requires: xine-plugins
Requires: xine-flac
%if %build_plf
Requires: xine-faad
%endif
%endif

%description
Muine is a music player for GNOME. Its UI has been designed from the
ground up to be very comfortable, and not just a clone of iTunes.
It is playlist-based, but does have a music library (not a traditional
one, though).
%if %build_plf
This package is in PLF, as it uses MPEG4 technology and might violate
some patents.
%endif

%prep
%setup -q
%patch -p1
%patch1 -p1

%build
# lower optimization, seems to be more stable
CFLAGS=`echo %{optflags} | sed 's/-O[0-9]/-O/'`
%configure2_5x \
%if %build_gst
  --enable-gstreamer=yes \
%else
  --enable-gstreamer=no \
%endif


make

%install
rm -rf %{buildroot}
GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1 %makeinstall_std
%if %_lib != lib
mv %buildroot%_libdir/mono %buildroot%monoprefix/
%endif

%find_lang %name
# menu entry
mkdir -p %{buildroot}%{_menudir}
cat > %{buildroot}%{_menudir}/%{name} << _EOF_
?package(%{name}): \
 command="%{_bindir}/muine" \
 icon="muine.png" \
 longtitle="Listen to your music" \
 needs="x11" \
 section="Multimedia/Sound" \
 title="Muine Music Player" \
 startup_notify="true"
_EOF_

# icons
mkdir -p %{buildroot}%{_iconsdir} %{buildroot}%{_miconsdir}
install -m 644 -D       ./data/images/muine.png %{buildroot}%{_liconsdir}/muine.png
convert -geometry 32x32 ./data/images/muine.png %{buildroot}%{_iconsdir}/muine.png
convert -geometry 16x16 ./data/images/muine.png %{buildroot}%{_miconsdir}/muine.png

# remove unwanted files
rm -f %{buildroot}%{_libdir}/%{name}/lib*.{a,la}

#add the plugins
mkdir -p %buildroot%monoprefix/%name/plugins
install -m 644 plugins/*.dll %buildroot%monoprefix/%name/plugins/
bzcat %SOURCE1 > %buildroot%monoprefix/%name/plugins/TrayIcon.dll.config

# ahead of time compile the executables for faster loading
export MONO_GAC_PREFIX=%buildroot%_prefix
#find %buildroot -name \*.exe -exec mono --aot -O=all,-shared {} \;

%post
%update_menus
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
for SCHEMA in muine; do
    gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/$SCHEMA.schemas > /dev/null
done

%preun
if [ "$1" = "0" ]; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    for SCHEMA in muine; do
        gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/$SCHEMA.schemas > /dev/null
    done
fi

%postun
%clean_menus

%clean
rm -rf %{buildroot}

%files -f %name.lang
%defattr(-, root, root)
%doc AUTHORS ChangeLog NEWS README TODO
%{_sysconfdir}/gconf/schemas/*.schemas
%{_bindir}/*
%dir %monoprefix/%{name}
%dir %monoprefix/%{name}/plugins
%monoprefix/%{name}/plugins/*
%dir %_libdir/%name
%_libdir/%name/*muine*
%_libdir/dbus-1.0/services/org.gnome.Muine.service
%monoprefix/monodoc/sources/*
%monoprefix/mono/muine/
%monoprefix/mono/gac/muine*
%_libdir/pkgconfig/*.pc
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/*

%{_menudir}/%{name}
%{_iconsdir}/muine.png
%{_miconsdir}/muine.png
%{_liconsdir}/muine.png

%changelog
* Thu Aug 25 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-8mdk
- drop prereq
- patch for new gtk-sharp2

* Mon Jun 20 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-7mdk
- fix buildrequires

* Wed Jun  1 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-6mdk
- fix bad muine startup script

* Wed May 25 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-5mdk
- hardcode plugin dir to /usr/lib/muine/plugins

* Tue May 10 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-4mdk
- disable broken aot compilation
- move dlls to /usr/lib on x86_64

* Mon May  9 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-3mdk
- add dll map for the trayicon plugin (bug #14760)

* Fri May  6 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-2mdk
- fix build on x86_64

* Fri May  6 2005 Gtz Waschk <waschk@mandriva.org> 0.8.3-1mdk
- fix deps
- switch to gstreamer backend by default
- new version

* Sat Apr 23 2005 Gtz Waschk <waschk@mandriva.org> 0.8.2-8mdk
- aot compile the exe

* Fri Apr 22 2005 Gtz Waschk <waschk@mandriva.org> 0.8.2-7mdk
- rebuild for new dbus-sharp
- drop mime stuff and depend on latest shared-mime-info

* Tue Apr 19 2005 Gtz Waschk <waschk@mandriva.org> 0.8.2-6mdk
- use mkrel macro

* Tue Mar 29 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.2-5mdk
- rebuild

* Wed Feb 23 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.2-4mdk
- rebuild for new dbus-sharp

* Sun Feb 20 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.2-3mdk
- fix mime script call

* Sat Feb 19 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.2-2mdk
- add mime registration for AAC files
- fix deps

* Thu Feb 17 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.2-1mdk
- new version

* Thu Feb 17 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.1-3mdk
- rebuild for new dbus-sharp

* Sat Feb  5 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.1-2mdk
- conditional MPEG4 metadata support

* Fri Feb  4 2005 Goetz Waschk <waschk@linux-mandrake.com> 0.8.1-1mdk
- New release 0.8.1

* Fri Jan 21 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.0-3mdk
- rebuild for new dbus-sharp

* Fri Jan 14 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.0-2mdk
- fix buildrequires

* Mon Jan 10 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.8.0-1mdk
- add new files
- disable parallel make
- New release 0.8.0

* Tue Dec 28 2004 Goetz Waschk <waschk@linux-mandrake.com> 0.7.1-1mdk
- New release 0.7.1

* Tue Dec 28 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.7.0-2mdk
- rebuild

* Mon Dec 27 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.7.0-1mdk
- we need gnome-sharp2 now
a- New release 0.7.0

* Wed Dec  8 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.3-4mdk
- rebuild for libgdbm3

* Mon Aug  2 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.3-3mdk
- rebuild for new flac

* Wed Jul 28 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.3-2mdk
- rebuild for new rpm

* Sat Jun 19 2004 Goetz Waschk <waschk@linux-mandrake.com> 0.6.3-1mdk
- New release 0.6.3

* Sun Jun  6 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.2-1mdk
- drop patches
- new version

* Sat Jun  5 2004 Marcel Pol <mpol@mandrake.org> 0.6.1-3mdk
- update (build)requires

* Thu Jun  3 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.1-2mdk
- patch away small syntax error
- remove workaround for bug 9713
- reenable libtoolize
- patch to build with new gtksharp

* Tue May 11 2004 Goetz Waschk <waschk@linux-mandrake.com> 0.6.1-1mdk
- New release 0.6.1

* Sun May  9 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.6.0-1mdk
- workaround bug #9713
- requires new mono and gtk-sharp
- add source URL
- new version

* Fri Apr  9 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.3-1mdk
- new version

* Mon Apr  5 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.2-1mdk
- new version

* Sun Apr  4 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.1-2mdk
- this uses xine instead of gstreamer as backend
- fix URL

* Sat Apr  3 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.1-1mdk
- requires new gtk-sharp
- new version

* Mon Mar  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.0-3mdk
- fix buildrequires

* Mon Mar  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.0-2mdk
- require gstreamer-GConf and gstreamer-audiosink

* Mon Mar  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.5.0-1mdk
- add new files
- requires new versions of mono and gtk-sharp
- new version

* Thu Feb 12 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.0-1mdk
- fix buildrequires
- new version

* Wed Feb  4 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.2-1mdk
- drop merged patch 0
- new version

* Mon Feb  2 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.1.1-1mdk
- drop patch 1
- new version

* Mon Feb  2 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.1-2mdk
- fix mono version check

* Sun Feb  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.1-1mdk
- requires gstreamer-flac
- new version

* Sun Feb  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.0-2mdk
- patch default gconf schema to fix bug 7237

* Wed Jan 28 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.3.0-1mdk
- fix menu section again
- fix file list
- new version

* Sat Jan 24 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2-2mdk
- new menu
- fix deps

* Fri Jan 23 2004 Abel Cheung <deaddog@deaddog.org> 0.2-1mdk
- First Mandrake package
